#include <iostream>
#include <thread>
#include <windows.h>
#include <vector>
#include <chrono>
#define READER
unsigned short total_people = 0;

#ifdef READER
#define door_count 4
#define max_people 100
char state[max_people];
#else
#define max_people_per_door 10
#define door_count 3
#endif

#ifdef USE_MUTEX
#include <mutex>
std::mutex osprac_mutex;
std::mutex osprac_mutex_console;
#endif
#ifdef USE_SEMAPHORE
HANDLE semaphore;
HANDLE semaphore_console;
#endif
#ifdef USE_CRITICAL_SECTION
CRITICAL_SECTION critical_section;
CRITICAL_SECTION critical_section_console;
#endif
void enter_door(short door_id) {
#ifndef READER
    bool limit_reached = false;
#endif
    while (true) {
#ifdef READER
        if(state[door_id]==1){
#ifdef USE_SEMAPHORE
            WaitForSingleObject(semaphore_console, INFINITE);
#endif
#ifdef USE_MUTEX
            osprac_mutex_console.lock();
#endif
#ifdef USE_CRITICAL_SECTION
            EnterCriticalSection(&critical_section_console);
#endif
            std::cout<<door_id<<" reading..."<<std::endl;
#ifdef USE_MUTEX
            osprac_mutex_console.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore_console, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
            LeaveCriticalSection(&critical_section_console);
#endif
            state[door_id]++;}
        else if(state[door_id]==2){
#ifdef USE_SEMAPHORE
            WaitForSingleObject(semaphore, INFINITE);
#endif
#ifdef USE_MUTEX
            osprac_mutex.lock();
#endif
#ifdef USE_CRITICAL_SECTION
            EnterCriticalSection(&critical_section);
#endif
#ifdef USE_SEMAPHORE
            WaitForSingleObject(semaphore_console, INFINITE);
#endif
#ifdef USE_MUTEX
            osprac_mutex_console.lock();
#endif
#ifdef USE_CRITICAL_SECTION
            EnterCriticalSection(&critical_section_console);
#endif
            std::cout<<door_id<<" finished Reding."<<std::endl;
#ifdef USE_MUTEX
            osprac_mutex.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
            LeaveCriticalSection(&critical_section);
#endif
total_people--;
#ifdef USE_MUTEX
            osprac_mutex_console.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore_console, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
            LeaveCriticalSection(&critical_section_console);
#endif
            std::this_thread::sleep_for(std::chrono::seconds(rand()%30));
            state[door_id]=0;
        }
#endif
#ifdef USE_SEMAPHORE
        WaitForSingleObject(semaphore, INFINITE);
#endif
#ifdef USE_MUTEX
        osprac_mutex.lock();
#endif
#ifdef USE_CRITICAL_SECTION
        EnterCriticalSection(&critical_section);
#endif
        if (total_people
            #ifdef READER
            <door_count&&(!state[door_id])
#else
                >=max_people_per_door * door_id
            #endif
            )
        {
#ifndef READER
            if (!limit_reached)std::cout << "Door " << door_id << ": Max people limit reached.\n";
            limit_reached = true;
        }
        else
        {       
#else
            total_people++;
#ifdef USE_MUTEX
            osprac_mutex.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
            LeaveCriticalSection(&critical_section);
#endif
            state[door_id]++;
#ifdef USE_SEMAPHORE
            WaitForSingleObject(semaphore_console, INFINITE);
#endif
#ifdef USE_MUTEX
            osprac_mutex_console.lock();
#endif
#ifdef USE_CRITICAL_SECTION
            EnterCriticalSection(&critical_section_console);
#endif
            std::cout<<door_id<<" starting Reding..."<<std::endl;
#ifdef USE_MUTEX
            osprac_mutex_console.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore_console, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
            LeaveCriticalSection(&critical_section_console);
#endif
        }else{
#ifdef USE_MUTEX
        osprac_mutex.unlock();
#endif
#ifdef USE_SEMAPHORE
        ReleaseSemaphore(semaphore, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
        LeaveCriticalSection(&critical_section);
#endif
        }
            std::this_thread::sleep_for(std::chrono::seconds(1));
#endif
#ifndef READER
            total_people++;
#ifdef USE_SEMAPHORE
            WaitForSingleObject(semaphore_console, INFINITE);
#endif
#ifdef USE_MUTEX
            osprac_mutex_console.lock();
#endif
#ifdef USE_CRITICAL_SECTION
            EnterCriticalSection(&critical_section_console);
#endif
            std::cout << "Person entered through door " << door_id << ". Total people: " << total_people << std::endl;
#ifdef USE_MUTEX
            osprac_mutex_console.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore_console, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
            LeaveCriticalSection(&critical_section_console);
#endif
            limit_reached = false;
        }
#ifdef USE_MUTEX
        osprac_mutex.unlock();
#endif
#ifdef USE_SEMAPHORE
        ReleaseSemaphore(semaphore, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
        LeaveCriticalSection(&critical_section);
#endif
        std::this_thread::sleep_for(std::chrono::seconds(1));
        if(!(rand()%7)&&total_people>0){
#ifdef USE_SEMAPHORE
            WaitForSingleObject(semaphore, INFINITE);
#endif
#ifdef USE_MUTEX
            osprac_mutex.lock();
#endif
#ifdef USE_CRITICAL_SECTION
            EnterCriticalSection(&critical_section);
#endif
            total_people--;
            std::cout << "Person exited through door " << door_id<< std::endl;
#ifdef USE_MUTEX
            osprac_mutex.unlock();
#endif
#ifdef USE_SEMAPHORE
            ReleaseSemaphore(semaphore,
            1, NULL);
#endif
#ifdef USE_CRITICAL_SECTION
            LeaveCriticalSection(&critical_section);
#endif
            std::this_thread::sleep_for(std::chrono::seconds(1));
        }
#endif
    }
}
int main() {
#ifdef READER
    for(char i=0;i<max_people;i++)state[i]=0;
#endif
#ifdef USE_SEMAPHORE
    semaphore = CreateSemaphore(NULL, 1, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTION
    // Ініціалізація критичної секції
    InitializeCriticalSection(&critical_section);
#endif
    std::vector<std::thread> threads;
    for (int i = 0; i <
                    #ifdef READER
                    max_people
                        #else
                    door_count
         #endif
         ; ++i) {
        threads.emplace_back(enter_door, i + 1);
    }
    while (true) {
#ifdef USE_SEMAPHORE
        WaitForSingleObject(semaphore_console, INFINITE);
#endif
#ifdef USE_MUTEX
        osprac_mutex_console.lock();
#endif
#ifdef USE_CRITICAL_SECTION
        EnterCriticalSection(&critical_section_console);
#endif
        std::cout << "Total people so far: " << total_people << std::endl;
#ifdef USE_MUTEX
        osprac_mutex_console.unlock();
#endif
#ifdef USE_SEMAPHORE
        ReleaseSemaphore(semaphore_console, 1, NULL);
#endif
#ifdef USE_CRITICAL_SECTIONs
        LeaveCriticalSection(&critical_section_console);
#endif
        std::this_thread::sleep_for(std::chrono::seconds(2));
    }
#ifdef USE_SEMAPHORE
    CloseHandle(semaphore);
#endif
    
#ifdef USE_CRITICAL_SECTION
    DeleteCriticalSection(&critical_section);
#endif
    return 0;
}
